=== debian/changelog ===
neuron (8.2.6-1) unstable; urgency=medium

  * New upstream version: 8.2.6
  * Update d/watch file
  * Refresh patches, drop ones that were merged upstream
  * Add python3.13-support.patch from upstream for Python 3.13 support
  * Update build dependencies
  * Add fix-missing-std-namespace.patch, gcc-15-fix.patch:
    - Resolves FTBFS with newer compilers (Closes: #1097455)
  * Add fix-gitless-build.patch: Make package build outside of a Git repo
  * Add missing link for nrnpyenv.sh to PATH
  * Add missing numpy ABI dependency

 -- Matthias Klumpp <mak@debian.org>  Sun, 04 May 2025 23:46:45 +0200

neuron (8.2.2-8) unstable; urgency=medium

  * Team upload.
  * Add upstream metadata
  * Reformatted the patches to "gbp pq" style
  * Cherry-picked patch from upstream for Python 3.13. Closes: #1092522

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 24 Feb 2025 13:38:27 +0100

neuron (8.2.2-7) unstable; urgency=medium

  * Team upload.
  * neuron-dev Depends: s/libopenmpi-dev/mpi-default-dev/
    Closes: #1076119
  * Standards-Version: 4.7.0 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 08 Aug 2024 15:39:52 +0200

neuron (8.2.2-6) unstable; urgency=medium

  * Team Upload.
  * Add patch to reove distutils usage (Closes: #1061311)
  * python3-neuron.install: fixup to get correct py lib installed
  * Cleanup files to fixup build-after-build (Closes: #1048047)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 27 Jan 2024 19:49:16 +0000

neuron (8.2.2-5) unstable; urgency=medium

  * Fix paths and dependencies to fix building models
    with nrnivmodl
  * tests: Add test for model compilation

 -- Matthias Klumpp <mak@debian.org>  Sun, 02 Jul 2023 22:42:25 +0200
