=== debian/tests/control ===
Tests: simple
Depends: build-essential,
         python3-neuron
Restrictions: allow-stderr

Tests: build-model
Depends: build-essential,
         neuron-dev
Restrictions: allow-stderr
