=== debian/watch ===
version=4

opts=\
  filenamemangle=s/.+\/@ANY_VERSION@\.tar\.gz/neuron-$1\.tar\.gz/,\
  uversionmangle=s/\.dev/~dev/ \
  https://github.com/neuronsimulator/nrn/tags .*/@ANY_VERSION@\.tar\.gz
